<!DOCTYPE html>
<html>
<head>
  <title>Promises test</title>
  <link rel="stylesheet" href="styles.css">
</head>
<body>
  <div class="network-fake">
    <label><input type="checkbox"> Fake network delay</label>
  </div>
  <div class="story"></div>
  <svg class="spinner" viewBox="0 0 100 100" width="20" height="20">
    <circle cx="50" cy="50" r="42" transform="rotate(-90,50,50)" />
  </svg>
  <script src="../js/utils.js"></script>
  <script>
    getJson('../data/story.json').then(function(story) {
      addHtmlToPage(story.heading);
      // Map our array of chapter urls
      // to an array of chapter json promises
      return story.chapterUrls.map(getJson).reduce(function(chain, chapterPromise) {
        // Use reduce to chain the promises together,
        // but adding content to the page for each chapter
        return chain.then(function() {
          return chapterPromise;
        }).then(function(chapter) {
          addHtmlToPage(chapter.html);
        });
      }, Promise.resolve());
    }).then(function() {
      addTextToPage("All done");
    }).catch(function(err) {
      // catch any error that happened along the way
      addTextToPage("Argh, broken: " + err.message);
    }).then(function() {
      document.querySelector('.spinner').style.display = 'none';
    });
  </script>
</body>
</html>